# This Python file uses the following encoding: utf-8
"""autogenerated by genpy from wireless_msgs/Connection.msg. Do not edit."""
import codecs
import sys
python3 = True if sys.hexversion > 0x03000000 else False
import genpy
import struct


class Connection(genpy.Message):
  _md5sum = "f1a0d060cec0bda21949621526aa056e"
  _type = "wireless_msgs/Connection"
  _has_header = False  # flag to mark the presence of a Header object
  _full_text = """float32 bitrate  # Mb/s
int16 txpower  # dBm

# Fractional link quality number preserved in raw
# field, resolved to decimal for link_quality field.
string link_quality_raw
float32 link_quality

int16 signal_level  # dBm
int16 noise_level  # dBm

string essid
string bssid
float64 frequency
"""
  __slots__ = ['bitrate','txpower','link_quality_raw','link_quality','signal_level','noise_level','essid','bssid','frequency']
  _slot_types = ['float32','int16','string','float32','int16','int16','string','string','float64']

  def __init__(self, *args, **kwds):
    """
    Constructor. Any message fields that are implicitly/explicitly
    set to None will be assigned a default value. The recommend
    use is keyword arguments as this is more robust to future message
    changes.  You cannot mix in-order arguments and keyword arguments.

    The available fields are:
       bitrate,txpower,link_quality_raw,link_quality,signal_level,noise_level,essid,bssid,frequency

    :param args: complete set of field values, in .msg order
    :param kwds: use keyword arguments corresponding to message field names
    to set specific fields.
    """
    if args or kwds:
      super(Connection, self).__init__(*args, **kwds)
      # message fields cannot be None, assign default values for those that are
      if self.bitrate is None:
        self.bitrate = 0.
      if self.txpower is None:
        self.txpower = 0
      if self.link_quality_raw is None:
        self.link_quality_raw = ''
      if self.link_quality is None:
        self.link_quality = 0.
      if self.signal_level is None:
        self.signal_level = 0
      if self.noise_level is None:
        self.noise_level = 0
      if self.essid is None:
        self.essid = ''
      if self.bssid is None:
        self.bssid = ''
      if self.frequency is None:
        self.frequency = 0.
    else:
      self.bitrate = 0.
      self.txpower = 0
      self.link_quality_raw = ''
      self.link_quality = 0.
      self.signal_level = 0
      self.noise_level = 0
      self.essid = ''
      self.bssid = ''
      self.frequency = 0.

  def _get_types(self):
    """
    internal API method
    """
    return self._slot_types

  def serialize(self, buff):
    """
    serialize message into buffer
    :param buff: buffer, ``StringIO``
    """
    try:
      _x = self
      buff.write(_get_struct_fh().pack(_x.bitrate, _x.txpower))
      _x = self.link_quality_raw
      length = len(_x)
      if python3 or type(_x) == unicode:
        _x = _x.encode('utf-8')
        length = len(_x)
      buff.write(struct.Struct('<I%ss'%length).pack(length, _x))
      _x = self
      buff.write(_get_struct_f2h().pack(_x.link_quality, _x.signal_level, _x.noise_level))
      _x = self.essid
      length = len(_x)
      if python3 or type(_x) == unicode:
        _x = _x.encode('utf-8')
        length = len(_x)
      buff.write(struct.Struct('<I%ss'%length).pack(length, _x))
      _x = self.bssid
      length = len(_x)
      if python3 or type(_x) == unicode:
        _x = _x.encode('utf-8')
        length = len(_x)
      buff.write(struct.Struct('<I%ss'%length).pack(length, _x))
      _x = self.frequency
      buff.write(_get_struct_d().pack(_x))
    except struct.error as se: self._check_types(struct.error("%s: '%s' when writing '%s'" % (type(se), str(se), str(locals().get('_x', self)))))
    except TypeError as te: self._check_types(ValueError("%s: '%s' when writing '%s'" % (type(te), str(te), str(locals().get('_x', self)))))

  def deserialize(self, str):
    """
    unpack serialized message in str into this message instance
    :param str: byte array of serialized message, ``str``
    """
    if python3:
      codecs.lookup_error("rosmsg").msg_type = self._type
    try:
      end = 0
      _x = self
      start = end
      end += 6
      (_x.bitrate, _x.txpower,) = _get_struct_fh().unpack(str[start:end])
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      start = end
      end += length
      if python3:
        self.link_quality_raw = str[start:end].decode('utf-8', 'rosmsg')
      else:
        self.link_quality_raw = str[start:end]
      _x = self
      start = end
      end += 8
      (_x.link_quality, _x.signal_level, _x.noise_level,) = _get_struct_f2h().unpack(str[start:end])
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      start = end
      end += length
      if python3:
        self.essid = str[start:end].decode('utf-8', 'rosmsg')
      else:
        self.essid = str[start:end]
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      start = end
      end += length
      if python3:
        self.bssid = str[start:end].decode('utf-8', 'rosmsg')
      else:
        self.bssid = str[start:end]
      start = end
      end += 8
      (self.frequency,) = _get_struct_d().unpack(str[start:end])
      return self
    except struct.error as e:
      raise genpy.DeserializationError(e)  # most likely buffer underfill


  def serialize_numpy(self, buff, numpy):
    """
    serialize message with numpy array types into buffer
    :param buff: buffer, ``StringIO``
    :param numpy: numpy python module
    """
    try:
      _x = self
      buff.write(_get_struct_fh().pack(_x.bitrate, _x.txpower))
      _x = self.link_quality_raw
      length = len(_x)
      if python3 or type(_x) == unicode:
        _x = _x.encode('utf-8')
        length = len(_x)
      buff.write(struct.Struct('<I%ss'%length).pack(length, _x))
      _x = self
      buff.write(_get_struct_f2h().pack(_x.link_quality, _x.signal_level, _x.noise_level))
      _x = self.essid
      length = len(_x)
      if python3 or type(_x) == unicode:
        _x = _x.encode('utf-8')
        length = len(_x)
      buff.write(struct.Struct('<I%ss'%length).pack(length, _x))
      _x = self.bssid
      length = len(_x)
      if python3 or type(_x) == unicode:
        _x = _x.encode('utf-8')
        length = len(_x)
      buff.write(struct.Struct('<I%ss'%length).pack(length, _x))
      _x = self.frequency
      buff.write(_get_struct_d().pack(_x))
    except struct.error as se: self._check_types(struct.error("%s: '%s' when writing '%s'" % (type(se), str(se), str(locals().get('_x', self)))))
    except TypeError as te: self._check_types(ValueError("%s: '%s' when writing '%s'" % (type(te), str(te), str(locals().get('_x', self)))))

  def deserialize_numpy(self, str, numpy):
    """
    unpack serialized message in str into this message instance using numpy for array types
    :param str: byte array of serialized message, ``str``
    :param numpy: numpy python module
    """
    if python3:
      codecs.lookup_error("rosmsg").msg_type = self._type
    try:
      end = 0
      _x = self
      start = end
      end += 6
      (_x.bitrate, _x.txpower,) = _get_struct_fh().unpack(str[start:end])
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      start = end
      end += length
      if python3:
        self.link_quality_raw = str[start:end].decode('utf-8', 'rosmsg')
      else:
        self.link_quality_raw = str[start:end]
      _x = self
      start = end
      end += 8
      (_x.link_quality, _x.signal_level, _x.noise_level,) = _get_struct_f2h().unpack(str[start:end])
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      start = end
      end += length
      if python3:
        self.essid = str[start:end].decode('utf-8', 'rosmsg')
      else:
        self.essid = str[start:end]
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      start = end
      end += length
      if python3:
        self.bssid = str[start:end].decode('utf-8', 'rosmsg')
      else:
        self.bssid = str[start:end]
      start = end
      end += 8
      (self.frequency,) = _get_struct_d().unpack(str[start:end])
      return self
    except struct.error as e:
      raise genpy.DeserializationError(e)  # most likely buffer underfill

_struct_I = genpy.struct_I
def _get_struct_I():
    global _struct_I
    return _struct_I
_struct_d = None
def _get_struct_d():
    global _struct_d
    if _struct_d is None:
        _struct_d = struct.Struct("<d")
    return _struct_d
_struct_f2h = None
def _get_struct_f2h():
    global _struct_f2h
    if _struct_f2h is None:
        _struct_f2h = struct.Struct("<f2h")
    return _struct_f2h
_struct_fh = None
def _get_struct_fh():
    global _struct_fh
    if _struct_fh is None:
        _struct_fh = struct.Struct("<fh")
    return _struct_fh
